import environs

env = environs.Env()
env.read_env("./.env")

db_type = env.str("DATABASE_TYPE", "sqlite")
db_name = env.str("DATABASE_NAME", "drive")

test_server = env.bool("TEST_SERVER", False)
modules_repo_branch = env.str("MODULES_REPO_BRANCH", "master")

try:
    api_id = env.int("API_ID")
    api_hash = env.str("API_HASH")
except environs.EnvError:
    api_id = input("Enter API_ID: ")
    api_hash = input("Enter API_HASH: ")

    _env = (
        f"API_ID={api_id}\n"
        f"API_HASH={api_hash}\n"
        f"DATABASE_TYPE={db_type}\n"
        f"DATABASE_NAME={db_name}\n"
    )

    with open(".env", "w") as file:
        file.write(_env)